//########################
//IllustratorCS3で繰り返し複製します。
//デフォルト値の移動量にオブジェクトのサイズが入り
//移動回数はページサイズ/オブジェクトサイズを四捨五入した値がはいるようになっています。
//値がptで取れるので10mmで設定していても誤差が出ている場合があります。
//########################

var myAns = new Array();
var myPt = 1;
var lineW=0.05;
main();
function main(){
	if (app.documents.length == 0){
		alert("ドキュメントを開いてください");
		return;
	}
	if (app.selection.length == 0){
		alert("オブジェクトを選択してください");
		return;
	}
	var myRU = app.activeDocument.rulerUnits;
	if(myRU == RulerUnits.Centimeters){myPt = 28.3466796875;}
	else if(myRU == RulerUnits.Millimeters){myPt = 2.83466796875;}
	
	var selbounds = getselectedbounds(app.selection);
	var dupWidth = app.activeDocument.width;
	var selWidth = selbounds[2]-selbounds[0];
	var motoXcount = Math.round(dupWidth/selWidth);
	var dupHeight = app.activeDocument.height;
	var selHeight = selbounds[1]-selbounds[3];
	var motoYcount = Math.round(dupHeight/selHeight);
	//ダイアログを作成する
	mydialog(selWidth/myPt,motoXcount,selHeight/myPt,motoYcount);
	//キャンセルなら終了
	if(myAns['cancel']){return;}
	//TOMBOを作る場合は下のコメント解除--★
	makeTombo(app.selection,myAns['xoffset'],myAns['xcount'],myAns['yoffset'],myAns['ycount'],myAns['tombo'],selbounds);
	//ここから処理を行う
	ai_dup_selected_box(app.selection,myAns['xoffset'],myAns['xcount'],myAns['yoffset'],myAns['ycount']);
}
function mydialog(dupWidth,motoXcount,dupheight,motoYcount){
	var myDialog = new Window("dialog", "保存", [0,0,250,220]);
	myDialog.add("statictext",[5,5,240,20],"選択されたオブジェクトを繰り返し複製します");
	myDialog.f1 = myDialog.add("panel",[5,25,240,90],"水平方向");
	myDialog.f1.add("statictext",[10,10,100,25],"繰り返し回数");
	myDialog.xcount = myDialog.f1.add("edittext",[110,10,220,25],motoXcount);
	myDialog.f1.add("statictext",[10,30,100,45],"オフセット");
	myDialog.xoffset = myDialog.f1.add("edittext",[110,30,220,45],dupWidth);
	
	myDialog.f1 = myDialog.add("panel",[5,100,240,165],"垂直方向");
	myDialog.f1.add("statictext",[10,10,100,25],"繰り返し回数");
	myDialog.ycount = myDialog.f1.add("edittext",[110,10,220,25],motoYcount);
	myDialog.f1.add("statictext",[10,30,100,45],"オフセット");
	myDialog.yoffset = myDialog.f1.add("edittext",[110,30,220,45],dupheight);
	//TOMBOを作る場合は下のコメント解除--★
	myDialog.tombo = myDialog.add("checkbox",[10,170,100,190],"トンボも作成");
	myDialog.ngBtn = myDialog.add("button",[60,190,150,210],"キャンセル", { name:"cancel"});
	myDialog.okBtn = myDialog.add("button",[160,190,230,210],"実行", { name:"ok"});
	myDialog.center();
	//キャンセルボタンクリック時の動作
	//myDialog.show();の前に記述するのがコツ
	myDialog.ngBtn.onClick = function () {
		myAns['cancel'] = true;
		myDialog.close();
		return;
	}
	myDialog.okBtn.onClick = function () {
		myAns['cancel'] = false;
		myAns['xcount'] = parseInt(myDialog.xcount.text);
		myAns['xoffset'] = parseFloat(myDialog.xoffset.text)*myPt;
		myAns['ycount'] = parseInt(myDialog.ycount.text);
		myAns['yoffset'] = parseFloat(myDialog.yoffset.text)*myPt;
		//TOMBOを作る場合は下のコメント解除--★
		if(myDialog.tombo.value){myAns['tombo']  = true;}else{myAns['tombo']  = false;}
		myDialog.close();
	}
	myDialog.show();
}
function ai_dup_selected_box(motoobj,xmovevalue,xcountvalue,ymovevalue,ycountvalue){
	for(var N = 0; N < motoobj.length;N++){
		var moto_bounds = motoobj[N].geometricBounds;
		var newx_pos = moto_bounds[0] ;
		for(var X = 0;X < xcountvalue;X++){
			var newy_pos = moto_bounds[1];
			for(var Y = 0;Y < ycountvalue;Y++){
				if(X == 0 && Y == 0){}else{
					var newobj = motoobj[N].duplicate();
					var mypos = new Array(newx_pos,newy_pos);
					newobj.position = mypos;
				}
				newy_pos = newy_pos - ymovevalue;
			}
			newx_pos = newx_pos + xmovevalue;
		}
	}
}

function getselectedbounds(motoobj){
	var moto_bounds = motoobj[0].geometricBounds;
	var orgx2 = moto_bounds[0];
	var orgy2 = moto_bounds[1];
	var orgx1 = moto_bounds[2] ;
	var orgy1 = moto_bounds[3] ;
	for(var N = 0; N < motoobj.length;N++){
		var moto_bounds = motoobj[N].geometricBounds;
		var newx1_pos = moto_bounds[0] ;
		var newy1_pos = moto_bounds[1] ;
		var newx2_pos = moto_bounds[2] ;
		var newy2_pos = moto_bounds[3] ;
		if(newx1_pos < orgx1){orgx1 = newx1_pos;}
		if(newy1_pos > orgy1){orgy1 = newy1_pos;}
		if(newx2_pos > orgx2){orgx2 = newx2_pos;}
		if(newy2_pos < orgy2){orgy2 = newy2_pos;}
	}
	return Array(orgx1,orgy1,orgx2,orgy2);
}

function makeTombo(motoobj,xmovevalue,xcountvalue,ymovevalue,ycountvalue,mytomboflg,selbounds){
	if(! mytomboflg){
		return;
	}
	var mygroup = activeDocument.groupItems.add();
	mygroup.name = "tombo";

	var orgx = selbounds[0] ;
	var orgy =  selbounds[1] ;
	var orgx2 =  selbounds[2] ;
	var orgy2 =  selbounds[3] ;
	var orgw = orgx2 - orgx;
	var orgh = orgy2 - orgy;
	var endx = orgx2 + (xmovevalue * (xcountvalue-1));
	var endy = orgy2 - (ymovevalue * (ycountvalue-1));
	
	//■■■■ここから縦の線を引いていく■■■■
	var Y1 = orgy + 13*myPt;
	var Y2 = orgy + 3*myPt;
	var Y1e = endy - 13*myPt;
	var Y2e = endy - 3*myPt;
	for(var X = 0;X < xcountvalue ;X++){
		var X1 = orgx + (xmovevalue * X);
		//上の線
		drowLine(X1,X1,Y1,Y2,lineW,mygroup);
		//下の線
		drowLine(X1,X1,Y1e,Y2e,lineW,mygroup);
		//もし選択の幅と移動量が違うなら線をもう一本
		if(orgw != xmovevalue){
			//上の線
			drowLine(X1+orgw,X1+orgw,Y1,Y2,lineW,mygroup);
			//下の線
			drowLine(X1+orgw,X1+orgw,Y1e,Y2e,lineW,mygroup);
		}
	}
	//もし選択の幅と移動量が同じなら最後に線をもう一本
	if(orgw == xmovevalue){
		drowLine(endx,endx,Y1,Y2,lineW,mygroup);
		drowLine(endx,endx,Y1e,Y2e,lineW,mygroup);
	}
	//■■■■ここまで■■■■
	//■■■■ここからヨコの線を引いていく■■■■
	var X1 = orgx - 13*myPt;
	var X2 = orgx - 3*myPt;
	var X1e = endx + 13*myPt;
	var X2e = endx + 3*myPt;
	for(var Y = 0;Y < ycountvalue ;Y++){
		var Y1 = orgy - (ymovevalue * Y);
		//左の線
		drowLine(X1,X2,Y1,Y1,lineW,mygroup);
		//右の線
		drowLine(X1e,X2e,Y1,Y1,lineW,mygroup);
		//もし選択の幅と移動量が違うなら線をもう一本
		if(orgh != ymovevalue){
			//左の線
			drowLine(X1,X2,Y1+orgh,Y1+orgh,lineW,mygroup);
			//右の線
			drowLine(X1e,X2e,Y1+orgh,Y1+orgh,lineW,mygroup);
		}
	}
	if(orgh == ymovevalue){
		drowLine(X1,X2,endy,endy,lineW,mygroup);
		drowLine(X1e,X2e,endy,endy,lineW,mygroup);
	}
}


function reColor(C,M,Y,K){
	var myCMYK=new CMYKColor();
	//var myColor=new Color();
	
	myCMYK.cyan=C;
	myCMYK.magenta=M;
	myCMYK.yellow=Y;
	myCMYK.black=K;
	
	//myColor.cmyk=myCMYK;
	return myCMYK;
}

function drowLine(X1,X2,Y1,Y2,lineW,mygroup){
	tomboColor=reColor(100,100,100,100);
	myLine=mygroup.pathItems.add();
	myLine.setEntirePath([[X1,Y1],[X2,Y2]])
	myLine.filled=false;
	myLine.stroked=true;
	myLine.strokeWidth=lineW*myPt;
	myLine.strokeColor=tomboColor;
}